﻿@model Lifestoned.DataModel.Gdle.SandboxModel

@{
    ViewBag.Title = "Sandbox";
}

<br />

@if (Model?.Entries == null || Model.Entries.Count() < 1)
{
    <div class="alert alert-info">
        There are no changes to review.
    </div>
}
else
{
    <div class="text-right">
        <i class="glyphicon glyphicon-filter"></i>
        <select id="sort" name="sort" onchange="filterChanged(event)">
            <option value="">All</option>
            <option value=".submitted">Submitted</option>
            <option value=".need-submit">Not Submitted</option>
        </select>
    </div>

    <div id="sandboxApp">
        @Html.DisplayFor(m => m.Entries)

        <lsd-spawn-map ref="mapDetails" :item="selectedMap" @@save="mapSaved"></lsd-spawn-map>
        
        <lsd-spell-table-entry ref="spellDetails" v-model="selectedSpell"></lsd-spell-table-entry>
    </div>

    @Html.Partial("CommentModal", new { source = "Sandbox" })

}


@section scripts
{
    @Scripts.Render("~/ui/shared", "~/ui/spawns", "~/ui/spellTable")

    <script>
        function filterChanged(evt) {
            $(".well").hide()
            $(".well" + $(evt.target).val()).show();
        }

        $(function () {
            $(".well").hide()
            $(".well" + $('#sort').val()).show();

            $('.sandbox-submit').click(function (evt) {
                evt.preventDefault();
                evt.stopPropagation();

                var el = $(this);
                var action = '../Sandbox/Submit';
                var text = 'Withdraw Submission';

                if (el.hasClass('btn-primary')) {
                    action = '../Sandbox/Withdraw';
                    text = 'Submit for Review';
                }

                $.post(action, { id: this.dataset.id, type: this.dataset.type }, function () {
                    el.toggleClass('btn-warning').toggleClass('btn-primary').text(text);
                    el.toggleClass('need-submit').toggleClass('submitted');
                    if ($('#sort').val() != '') {
                        el.parents('.well').first().hide();
                    }
                });
            });

            $('.sandbox-delete').click(function (evt) {
                if (confirm('This will remove the item, proceed?')) {
                    evt.preventDefault();
                    evt.stopPropagation();

                    var el = $(this);
                    $.post('../Sandbox/Delete', { id: this.dataset.id, type: this.dataset.type }, function () {
                        el.parents('.well').first().remove();
                    });
                }
            });

        });

        Vue.use(AutoWatchMixin);
        Vue.use(SpellTableStore);
        var spellTableStore = makeSpellTableService();

        var sandboxApp = new Vue({
            el: '#sandboxApp',
            spellTableStore: spellTableStore,
            data: {
                selectedMap: null,
                selectedSpell: this.spellTableStore.newSpell()
            },

            methods: {
                editSpell(spellId) {
                    var $this = this;
                    this.$spellTable.fetch(spellId).then((spell) => {
                        $this.selectedSpell = spell;
                        $this.$refs.spellDetails.show();
                    });
                },

                editMap(mapId) {
                    var $i = this;
                    $.get('../Spawn/Map', { id: mapId }, function (data) {
                        $i.selectedMap = data;
                        $i.$refs.mapDetails.show();
                    });
                },

                mapSaved(item) {
                    var $i = this;
                    $.post('Spawn/Save', { map: item }, function (data) {
                        alert('Changes saved to sandbox');
                        $i.$refs.mapDetails.hide();
                    });
                }
            },
            mounted() {
            },
            destroyed() {
            }
        });

    </script>

}